import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class newOFProject extends PApplet {


String projectName = "";
boolean shiftPressed = false;

public void setup() {
  size(200, 100);
}

public void draw() {
  background(0);
  text(projectName, 50, 50);
}

public void keyPressed() {
  if (keyCode==BACKSPACE) {
    projectName = projectName.substring(0, projectName.length()-1);
  } 
  else if (keyCode==ENTER) {
    createProject();
  } 
  else if (keyCode==SHIFT) {
    shiftPressed=true;
  }
  else {
    String ch = str(PApplet.parseChar(keyCode));
    if (shiftPressed) ch = ch.toUpperCase();
    else ch = ch.toLowerCase();
    projectName += ch;
  }
}

public void keyReleased() {
  if (keyCode==SHIFT) {
    shiftPressed=false;
  }
}

public void createProject() {
  if (projectName.length()==0) projectName = "newProject";
  try { 
    copyDirectory("./emptyExample", "../myApps/"+projectName);
  } 
  catch (IOException e) {
    System.err.println(e);
  }
  renameFile("../myApps/"+projectName+"/emptyExample.cbp", "../myApps/"+projectName+"/"+projectName+".cbp");
  renameFile("../myApps/"+projectName+"/emptyExample.layout", "../myApps/"+projectName+"/"+projectName+".layout");
  renameFile("../myApps/"+projectName+"/emptyExample.workspace", "../myApps/"+projectName+"/"+projectName+".workspace");  
  renameFile("../myApps/"+projectName+"/emptyExample.depend", "../myApps/"+projectName+"/"+projectName+".depend");
  String[] input = loadStrings("../myApps/"+projectName+"/"+projectName+".cbp");
  for (int i=0;i<input.length;i++) {
    input[i] = input[i].replaceAll("emptyExample", projectName);
  }
  saveStrings("../myApps/"+projectName+"/"+projectName+".cbp", input);
  input = loadStrings("../myApps/"+projectName+"/"+projectName+".workspace");
  for (int i=0;i<input.length;i++) {
    input[i] = input[i].replaceAll("emptyExample", projectName);
  }
  saveStrings("../myApps/"+projectName+"/"+projectName+".workspace", input);
  exit();
}

public void renameFile(String urlA, String urlB) {
  File file = new File(sketchPath(urlA));
  File file2 = new File(sketchPath(urlB));  

  // Rename file (or directory)
  boolean success = file.renameTo(file2);
  if (!success) {
    // File was not successfully renamed
  }
}

public void copyDirectory(String urlA, String urlB) throws IOException {
  File srcDir = new File(sketchPath(urlA));
  File dstDir = new File(sketchPath(urlB));  
  copyDirectoryRec(srcDir, dstDir);
}

// Copies all files under srcDir to dstDir.
// If dstDir does not exist, it will be created.
public void copyDirectoryRec(File srcDir, File dstDir) throws IOException {
  if (srcDir.isDirectory()) {
    if (!dstDir.exists()) {
      dstDir.mkdir();
    }
    String[] children = srcDir.list();
    for (int i=0; i<children.length; i++) {
      copyDirectoryRec(new File(srcDir, children[i]), 
      new File(dstDir, children[i]));
    }
  } 
  else {
    // This method is implemented in Copying a File
    copyFile(srcDir, dstDir);
  }
}

// Copies src file to dst file.
// If the dst file does not exist, it is created
public void copyFile(File src, File dst) throws IOException {
  InputStream in = new FileInputStream(src);
  OutputStream out = new FileOutputStream(dst);

  // Transfer bytes from in to out
  byte[] buf = new byte[1024];
  int len;
  while ( (len = in.read (buf)) > 0) {
    out.write(buf, 0, len);
  }
  in.close();
  out.close();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#D4D0C8", "newOFProject" });
  }
}
